; Scheme Definitions of Application chapter
; By Nils M Holm, 2016, 2018
;
; Provided under the Creative Common Zero (CC0) license
; (https://creativecommons.org/publicdomain/zero/1.0/)
;
; From the book COMPILING LAMBDA CALCULUS, http://t3x.org/clc/

; Examples: (factorial 5)
;           (length '(1 2 3 4 5))
;           ((append '(a b c)) '(d e f))

(define factorial
  (Y (lambda (f)
       (lambda (x)
         (if (zero? x)
             1
             (* x (f (- x 1))))))))

(define length
  (Y (lambda (f)
       (lambda (x)
         (if (null? x)
             0
             (+ 1 (f (cdr x))))))))

(define append
  (Y (lambda (f)
       (lambda (x)
         (lambda (y)
           (if (null? x)
               y
               (cons (car x)
                     ((f (cdr x)) y)))))))) 
